OPENSSL-FIPSINSTALL(1)

NAME
openssl-fipsinstall - perform FIPS configuration installation

SYNOPSIS
openssl fipsinstall [-help] [-in configfilename] [-out configfilename] [-module modulefilename] [-provider_name providername] [-section_name sectionname] [-verify] [-mac_name macname] [-macopt nm:v] [-noout] [-corrupt_desc selftest_description] [-corrupt_type selftest_type]

DESCRIPTION
This command is used to generate a FIPS module configuration file. The generated configuration file consists of:

- A mac of the FIPS module file.
- A status indicator that indicates if the known answer Self Tests (KAT's) have successfully run.

This configuration file can be used each time a FIPS module is loaded in order to pass data to the FIPS modules self tests. The FIPS module always verifies the modules MAC, but only needs to run the KATS once during install.

OPTIONS

-help
    Print a usage message.

-module filename
    Filename of a fips module to perform an integrity check on.

-out configfilename
    Filename to output the configuration data to, or standard output by default.

-in configfilename
    Input filename to load configuration data from. Used with the '-verify' option. Standard input is used if the filename is '-'.

-verify
    Verify that the input configuration file contains the correct information

-provider_name providername
    Name of the provider inside the configuration file.

-section_name sectionname
    Name of the section inside the configuration file.

-mac_name name
    Specifies the name of a supported MAC algorithm which will be used. To see the list of supported MAC's use the command "openssl list -mac-algorithms". The default is HMAC.

-macopt nm:v
    Passes options to the MAC algorithm. A comprehensive list of controls can be found in the EVP_MAC implementation documentation. Common control strings used for fipsinstall are:

    key:string
        Specifies the MAC key as an alphanumeric string (use if the key contains printable characters only). The string length must conform to any restrictions of the MAC algorithm. A key must be specified for every MAC algorithm.

    hexkey:string
        Specifies the MAC key in hexadecimal form (two hex digits per byte). The key length must conform to any restrictions of the MAC algorithm. A key must be specified for every MAC algorithm.

    digest:string
        Used by HMAC as an alphanumeric string (use if the key contains printable characters only). The string length must conform to any restrictions of the MAC algorithm. To see the list of supported digests, use the command "openssl list -digest-commands".

-noout
    Disable logging of the self tests.

-corrupt_desc selftest_description
-corrupt_type selftest_type
    The corrupt options can be used to test failure of one or more self test(s) by name. Either option or both may be used to select the self test(s) to corrupt. Refer to the entries for "st-desc" and "st-type" in OSSL_PROVIDER-FIPS(7) for values that can be used.

EXAMPLES
Calculate the mac of a FIPS module fips.so and run a FIPS self test for the module, and save the fips.conf configuration file:

 openssl fipsinstall -module ./fips.so -out fips.conf -provider_name fips \
         -section_name fipsinstall -mac_name HMAC -macopt digest:SHA256 \
         -macopt hexkey:000102030405060708090A0B0C0D0E0F10111213

Verify that the configuration file fips.conf contains the correct info:

 openssl fipsinstall -module ./fips.so -in fips.conf  -provider_name fips \
          -section_name fips_install -mac_name HMAC -macopt digest:SHA256 \
          -macopt hexkey:000102030405060708090A0B0C0D0E0F10111213 -verify

Corrupt any self tests which have the description 'SHA1':

 openssl fipsinstall -module ./fips.so -out fips.conf -provider_name fips \
         -section_name fipsinstall -mac_name HMAC -macopt digest:SHA256 \
         -macopt hexkey:000102030405060708090A0B0C0D0E0F10111213 \
         -corrupt_desc', 'SHA1'

NOTES
The MAC mechanisms that are available will depend on the options used when building OpenSSL. The command "openssl list -mac-algorithms" command can be used to list them.

SEE ALSO
fips_config(5), OSSL_PROVIDER-FIPS(7), EVP_MAC(3)

COPYRIGHT
Copyright 2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at <https://www.openssl.org/source/license.html>.